%define anolis_release 5
%global _hardened_build 1
%bcond_with sdt

Name:     dhcp
Version:  4.4.3
Release:  %{anolis_release}.P1%{?dist}
Summary:  Dynamic host configuration protocol software
Epoch:    12
License:  ISC and MPLv2.0
Url:      https://www.isc.org/dhcp/
Source0:  https://downloads.isc.org/isc/dhcp/%{version}-P1/%{name}-%{version}-P1.tar.gz
Source1:  dhclient-script
Source2:  README.dhclient.d
Source3:  11-dhclient
Source4:  56dhclient
Source5:  dhcpd.service
Source6:  dhcpd6.service
Source7:  dhcrelay.service
Source8:  dhcp.sysusers

Patch1 : 0001-change-bug-url.patch
Patch2 : 0002-additional-dhclient-options.patch
Patch3 : 0003-Handle-releasing-interfaces-requested-by-sbin-ifup.patch
Patch4 : 0004-Support-unicast-BOOTP-for-IBM-pSeries-systems-and-ma.patch
Patch5 : 0005-Change-default-requested-options.patch
Patch7 : 0007-Change-paths-to-conform-to-our-standards.patch
Patch8 : 0008-Make-sure-all-open-file-descriptors-are-closed-on-ex.patch
Patch9 : 0009-Fix-garbage-in-format-string-error.patch
Patch10 : 0010-Handle-null-timeout.patch
Patch11 : 0011-Drop-unnecessary-capabilities.patch
Patch12 : 0012-RFC-3442-Classless-Static-Route-Option-for-DHCPv4-51.patch
Patch13 : 0013-DHCPv6-over-PPP-support-626514.patch
Patch14 : 0014-IPoIB-support-660681.patch
Patch15 : 0015-Add-GUID-DUID-to-dhcpd-logs-1064416.patch
Patch16 : 0016-Turn-on-creating-sending-of-DUID.patch
Patch17 : 0017-Send-unicast-request-release-via-correct-interface.patch
Patch18 : 0018-No-subnet-declaration-for-iface-should-be-info-not-e.patch
Patch19 : 0019-dhclient-write-DUID_LLT-even-in-stateless-mode-11563.patch
Patch20 : 0020-Discover-all-hwaddress-for-xid-uniqueness.patch
Patch21 : 0021-Load-leases-DB-in-non-replay-mode-only.patch
Patch22 : 0022-dhclient-make-sure-link-local-address-is-ready-in-st.patch
Patch23 : 0023-option-97-pxe-client-id.patch
Patch24 : 0024-Detect-system-time-changes.patch
Patch25 : 0025-bind-Detect-system-time-changes.patch
Patch26 : 0026-Add-dhclient-5-B-option-description.patch
Patch27 : 0027-Add-missed-sd-notify-patch-to-manage-dhcpd-with-syst.patch
Patch28 : 0028-Use-system-getaddrinfo-for-dhcp.patch
Patch29 : CVE-2021-25220.patch

BuildRequires: autoconf automake make
BuildRequires: openldap-devel krb5-devel libcap-ng-devel
BuildRequires: systemd systemd-devel
BuildRequires: gnupg2 libtool doxygen

%if %{with sdt}
BuildRequires: systemtap-sdt-devel
%global tapsetdir    /usr/share/systemtap/tapset
%endif

%description
The Dynamic Host Configuration Protocol (DHCP) is a network protocol used to
assign IP addresses and provide configuration information to devices such as
servers, desktops, or mobile devices, so they can communicate on a network using
the Internet Protocol (IP). ISC DHCP is a collection of software that implements
all aspects of the DHCP (Dynamic Host Configuration Protocol) suite.

%package server
Summary: Provides the ISC DHCP server
Requires: %{name}-common = %{EVR}
Requires(post): coreutils grep sed

Obsoletes: %{name}-compat < 12:4.4.2-12.b1
%{?sysusers_requires_compat}
%{?systemd_requires}

%description server
The Dynamic Host Configuration Protocol (DHCP) is a network protocol used to
assign IP addresses and provide configuration information to devices such as
servers, desktops, or mobile devices, so they can communicate on a network using
the Internet Protocol (IP). ISC DHCP is a collection of software that implements
all aspects of the DHCP (Dynamic Host Configuration Protocol) suite.

A DHCP server receives clients' requests and replies to them.

%package relay
Summary: Provides the ISC DHCP relay agent
Requires: %{name}-common = %{EVR}
Obsoletes: %{name}-compat < 12:4.4.2-12.b1
Requires(post): grep sed systemd
Requires(preun): systemd
Requires(postun): systemd

%description relay
The Dynamic Host Configuration Protocol (DHCP) is a network protocol used to
assign IP addresses and provide configuration information to devices such as
servers, desktops, or mobile devices, so they can communicate on a network using
the Internet Protocol (IP). ISC DHCP is a collection of software that implements
all aspects of the DHCP (Dynamic Host Configuration Protocol) suite.

A DHCP relay agent passes DHCP requests from one LAN to another, so that a DHCP
server is not needed on every LAN.

%package client
Summary: Provides the ISC DHCP client daemon and dhclient-script
Provides: dhclient = %{EVR}
Obsoletes: dhclient < %{EVR}
Requires: coreutils gawk grep ipcalc iproute iputils sed systemd
Requires: %{name}-common = %{EVR}
Conflicts: NetworkManager < 1.20

%description client
The Dynamic Host Configuration Protocol (DHCP) is a network protocol used to
assign IP addresses and provide configuration information to devices such as
servers, desktops, or mobile devices, so they can communicate on a network using
the Internet Protocol (IP). ISC DHCP is a collection of software that implements
all aspects of the DHCP (Dynamic Host Configuration Protocol) suite.

A DHCP client can be bundled with the operating system of a client computer
or other IP capable device; it sends configuration requests to the server.
Most devices and operating systems already have DHCP clients included.

%package common
Summary: Common files used by ISC dhcp client, server and relay agent
BuildArch: noarch
Obsoletes: dhcp-libs < %{epoch}:%{version}

%description common
This package provides common files used by dhcp and dhclient package.

%package libs-static
Summary: Shared libraries used by ISC dhcp client and server
Provides: %{name}-libs = %{EVR}
Provides: bundled(bind-export-libs) bundled(bind)
Obsoletes: %{name}-devel-doc < %{EVR}

%description libs-static
This package contains shared libraries used by ISC dhcp client and server

%package devel
Summary: Development headers and libraries for interfacing to the DHCP server
Requires: %{name}-libs = %{EVR}

%description devel
Header files and API documentation for using the ISC DHCP libraries.  The
libdhcpctl and libomapi static libraries are also included in this package.

%prep
%setup -n %{name}-%{version}-P1
pushd bind
tar -xvf bind.tar.gz; ln -s bind-9* bind
popd
%autopatch -p1

for page in client/dhclient.conf.5 client/dhclient.leases.5 client/dhclient-script.8 client/dhclient.8 ; do
    sed -i 's|CLIENTBINDIR|%{_sbindir}|g' $page
    sed -i 's|RUNDIR|%{_localstatedir}/run|g' $page
    sed -i 's|DBDIR|%{_localstatedir}/lib/dhclient|g' $page
    sed -i 's|ETCDIR|%{_sysconfdir}/%{name}|g' $page
done

for page in server/dhcpd.conf.5 server/dhcpd.leases.5 server/dhcpd.8 ; do
    sed -i 's|CLIENTBINDIR|%{_sbindir}|g' $page
    sed -i 's|RUNDIR|%{_localstatedir}/run|g' $page
    sed -i 's|DBDIR|%{_localstatedir}/lib/dhcpd|g' $page
    sed -i 's|ETCDIR|%{_sysconfdir}/%{name}|g' $page
done

sed -i 's|/var/db/|%{_localstatedir}/lib/dhcpd/|g' contrib/dhcp-lease-list.pl

%build
autoreconf -fiv

CFLAGS="%{optflags} -fno-strict-aliasing -fcommon" \
%configure \
    --with-srv-lease-file=%{_localstatedir}/lib/dhcpd/dhcpd.leases \
    --with-srv6-lease-file=%{_localstatedir}/lib/dhcpd/dhcpd6.leases \
    --with-cli-lease-file=%{_localstatedir}/lib/dhclient/dhclient.leases \
    --with-cli6-lease-file=%{_localstatedir}/lib/dhclient/dhclient6.leases \
    --with-srv-pid-file=%{_localstatedir}/run/dhcpd.pid \
    --with-srv6-pid-file=%{_localstatedir}/run/dhcpd6.pid \
    --with-cli-pid-file=%{_localstatedir}/run/dhclient.pid \
    --with-cli6-pid-file=%{_localstatedir}/run/dhclient6.pid \
    --with-relay-pid-file=%{_localstatedir}/run/dhcrelay.pid \
    --with-ldap \
    --with-ldapcrypto \
    --with-ldap-gssapi \
    --enable-log-pid \
%if %{with sdt}
    --enable-systemtap \
    --with-tapset-install-dir=%{tapsetdir} \
%endif
    --enable-paranoia --enable-early-chroot \
    --enable-binary-leases \
    --with-systemd
make

%install
%make_install

rm -f %{buildroot}%{_sysconfdir}/{dhclient.conf.example,dhcpd.conf.example}
install -D -pm 0755 %{SOURCE1} %{buildroot}%{_sbindir}/dhclient-script
install -pm 0644 %{SOURCE2} .
mkdir -p %{buildroot}%{_sysconfdir}/%{name}/dhclient.d
mkdir -p %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -pm 0755 %{SOURCE3} %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -D -pm 0755 %{SOURCE4} %{buildroot}%{_libdir}/pm-utils/sleep.d/56dhclient

mkdir -p %{buildroot}%{_unitdir}
install -m 644 %{SOURCE5} %{SOURCE6} %{SOURCE7} %{buildroot}%{_unitdir}
install -D -pm 0644 %{SOURCE8} %{buildroot}%{_sysusersdir}/dhcp.conf

mkdir -p %{buildroot}%{_localstatedir}/lib/dhclient/
mkdir -p %{buildroot}%{_localstatedir}/lib/dhcpd/
touch %{buildroot}%{_localstatedir}/lib/dhcpd/{dhcpd.leases,dhcpd6.leases}

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
cat <<EOF > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd
# WARNING: This file is NOT used anymore.

# If you are here to restrict what interfaces should dhcpd listen on,
# be aware that dhcpd listens *only* on interfaces for which it finds subnet
# declaration in dhcpd.conf. It means that explicitly enumerating interfaces
# also on command line should not be required in most cases.

# If you still insist on adding some command line options,
# copy dhcpd.service from /lib/systemd/system to /etc/systemd/system and modify
# it there.

# example:
# $ cp /usr/lib/systemd/system/dhcpd.service /etc/systemd/system/
# $ vi /etc/systemd/system/dhcpd.service
# $ ExecStart=/usr/sbin/dhcpd -f -cf /etc/dhcp/dhcpd.conf -user dhcpd -group dhcpd --no-pid <your_interface_name(s)>
# $ systemctl --system daemon-reload
# $ systemctl restart dhcpd.service
EOF

# Copy sample conf files into position (called by doc macro)
cp -p doc/examples/dhclient-dhcpv6.conf client/dhclient6.conf.example
cp -p doc/examples/dhcpd-dhcpv6.conf server/dhcpd6.conf.example

cat << EOF > client/dhclient-enter-hooks
#!/bin/bash

# For dhclient/dhclient-script debugging.
# Copy this into /etc/dhcp/ and make it executable.
# Run 'dhclient -d <interface>' to see info passed from dhclient to dhclient-script.
# See also HOOKS section in dhclient-script(8) man page.

echo "interface: ${interface}"
echo "reason: ${reason}"

( set -o posix ; set ) | grep "old_"
( set -o posix ; set ) | grep "new_"
( set -o posix ; set ) | grep "alias_"
( set -o posix ; set ) | grep "requested_"
EOF

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cat << EOF > %{buildroot}%{_sysconfdir}/%{name}/dhcpd.conf
#
# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp-server/dhcpd.conf.example
#   see dhcpd.conf(5) man page
#
EOF

cat << EOF > %{buildroot}%{_sysconfdir}/%{name}/dhcpd6.conf
#
# DHCPv6 Server Configuration file.
#   see /usr/share/doc/dhcp-server/dhcpd6.conf.example
#   see dhcpd.conf(5) man page
#
EOF

install -D -pm 0644 contrib/ldap/dhcp.schema %{buildroot}%{_sysconfdir}/openldap/schema/dhcp.schema

find %{buildroot} -type f -name "*.la" -delete -print

%generate_compatibility_deps

%pre server
%sysusers_create_compat %{SOURCE11}

%post server
%systemd_post dhcpd.service dhcpd6.service

for servicename in dhcpd dhcpd6; do
  etcservicefile=%{_sysconfdir}/systemd/system/${servicename}.service
  if [ -f ${etcservicefile} ]; then
    grep -q Type= ${etcservicefile} || sed -i '/\[Service\]/a Type=notify' ${etcservicefile}
    sed -i 's/After=network.target/Wants=network-online.target\nAfter=network-online.target/' ${etcservicefile}
  fi
done
exit 0

%post relay
%systemd_post dhcrelay.service

for servicename in dhcrelay; do
  etcservicefile=%{_sysconfdir}/systemd/system/${servicename}.service
  if [ -f ${etcservicefile} ]; then
    grep -q Type= ${etcservicefile} || sed -i '/\[Service\]/a Type=notify' ${etcservicefile}
    sed -i 's/After=network.target/Wants=network-online.target\nAfter=network-online.target/' ${etcservicefile}
  fi
done
exit 0

%preun server
%systemd_preun dhcpd.service dhcpd6.service

%preun relay
%systemd_preun dhcrelay.service

%postun server
%systemd_postun_with_restart dhcpd.service dhcpd6.service

%postun relay
%systemd_postun_with_restart dhcrelay.service

%triggerun -- dhcp
for servicename in dhcpd dhcpd6 dhcrelay; do
  if [ -f %{_sysconfdir}/sysconfig/${servicename} ]; then
    source %{_sysconfdir}/sysconfig/${servicename}
    if [ "${servicename}" == "dhcrelay" ]; then
        args=$DHCRELAYARGS
    else
        args=$DHCPDARGS
    fi
    if [ -n "${args}" -a ! -f %{_sysconfdir}/systemd/system/${servicename}.service ]; then
      args=$(echo $args | sed 's/\//\\\//'g)
      sed -r -e "/ExecStart=/ s/$/ ${args}/" \
                < %{_unitdir}/${servicename}.service \
                > %{_sysconfdir}/systemd/system/${servicename}.service
    fi
  fi
done

%files server
%attr(0750,root,root) %dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%config(noreplace) %{_sysconfdir}/%{name}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/%{name}/dhcpd6.conf
%dir %{_sysconfdir}/openldap/schema
%config(noreplace) %{_sysconfdir}/openldap/schema/dhcp.schema
%attr(0755,dhcpd,dhcpd) %dir %{_localstatedir}/lib/dhcpd
%attr(0644,dhcpd,dhcpd) %verify(mode) %config(noreplace) %{_localstatedir}/lib/dhcpd/dhcpd.leases
%attr(0644,dhcpd,dhcpd) %verify(mode) %config(noreplace) %{_localstatedir}/lib/dhcpd/dhcpd6.leases
%attr(0644,root,root)   %{_unitdir}/dhcpd.service
%attr(0644,root,root)   %{_unitdir}/dhcpd6.service
%{_sysusersdir}/dhcp.conf

%{_bindir}/omshell
%{_sbindir}/dhcpd

%dir %{abidir}
%{abidir}/dhcpd-option.list
%attr(0644,root,root) %{_mandir}/man1/omshell.1.*
%attr(0644,root,root) %{_mandir}/man5/dhcpd.conf.5.*
%attr(0644,root,root) %{_mandir}/man5/dhcpd.leases.5.*
%attr(0644,root,root) %{_mandir}/man8/dhcpd.8.*
%if %{with sdt}
%{tapsetdir}/*.stp
%endif

%doc server/*
%doc contrib/ldap/ contrib/dhcp-lease-list.pl

%files relay
%{_sbindir}/dhcrelay
%attr(0644,root,root) %{_unitdir}/dhcrelay.service
%{abidir}/dhcrelay-option.list
%attr(0644,root,root) %{_mandir}/man8/dhcrelay.8.*

%files client
%attr(0750,root,root) %dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/dhclient.d
%dir %{_prefix}/lib/NetworkManager
%dir %{_prefix}/lib/NetworkManager/dispatcher.d
%{_prefix}/lib/NetworkManager/dispatcher.d/11-dhclient
%dir %{_localstatedir}/lib/dhclient

%{_sbindir}/dhclient
%{_sbindir}/dhclient-script
%attr(0755,root,root) %{_libdir}/pm-utils/sleep.d/56dhclient

%{abidir}/dhclient-option.list
%attr(0644,root,root) %{_mandir}/man5/dhclient.conf.5.*
%attr(0644,root,root) %{_mandir}/man5/dhclient.leases.5.*
%attr(0644,root,root) %{_mandir}/man8/dhclient.8.*
%attr(0644,root,root) %{_mandir}/man8/dhclient-script.8.*

%doc README.dhclient.d
%doc client/*

%files common
%attr(0644,root,root) %{_mandir}/man5/dhcp-options.5.*
%attr(0644,root,root) %{_mandir}/man5/dhcp-eval.5.*
%license LICENSE
%doc README RELNOTES doc/References.txt

%files libs-static
%{_libdir}/libdhcp.a
%{_libdir}/libdhcpctl.a
%{_libdir}/libomapi.a

%files devel
%{_includedir}/dhcpctl
%{_includedir}/omapip
%attr(0644,root,root) %{_mandir}/man3/dhcpctl.3.*
%attr(0644,root,root) %{_mandir}/man3/omapi.3.*
%doc doc/IANA-arp-parameters doc/api+protocol

%changelog
* Thu Apr 13 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 12:4.4.3-P1-5
- Refactor the specfile and remove devel-doc sub-package

* Mon Mar 27 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 12:4.4.3-P1-4
- Del Specific Fields

* Mon Jan  9 2023 Heng Qi <hengqi@linux.alibaba.com> - 12:4.4.3-P1-3
- update to 4.4.3-P1

* Tue Nov 1 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 12:4.4.3-2
- optimise spec file

* Thu Sep 22 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 12:4.4.3-1
- update to 4.4.3

* Wed Mar 09 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 12:4.4.2-1.P1
- init from upstream 4.4.2.p1
- add patches to keep backend compat
